function love.load()
  
  -- basic setup --
  love.window.setTitle("Ball Booster")
  love.mouse.setVisible(false)
  love.graphics.setDefaultFilter("nearest","nearest")
  ww = 0
  wh = 0
  love.graphics.setBackgroundColor(104/255,136/255,248/255)
  -----------------
  
  -- load assets --
  imgPath = "assets/images/"
  sndPath = "assets/sounds/"
  musPath = "assets/music/"
  coinSPR1 = love.graphics.newImage(imgPath.."coin1.png")
  coinSPR2 = love.graphics.newImage(imgPath.."coin2.png")
  lockedSlot = love.graphics.newImage(imgPath.."locked.png")
  unlockedSlot = love.graphics.newImage(imgPath.."unlocked.png")
  ball1 = love.graphics.newImage(imgPath.."ball1.png")
  ball2 = love.graphics.newImage(imgPath.."ball2.png")
  ball3 = love.graphics.newImage(imgPath.."ball3.png")
  ball4 = love.graphics.newImage(imgPath.."ball4.png")
  ball5 = love.graphics.newImage(imgPath.."ball5.png")
  ball6 = love.graphics.newImage(imgPath.."ball6.png")
  ball7 = love.graphics.newImage(imgPath.."ball7.png")
  ball8 = love.graphics.newImage(imgPath.."ball8.png")
  ball9 = love.graphics.newImage(imgPath.."ball9.png")
  ball10 = love.graphics.newImage(imgPath.."ball10.png")
  ball11 = love.graphics.newImage(imgPath.."ball11.png")
  ball12 = love.graphics.newImage(imgPath.."ball12.png")
  ball13 = love.graphics.newImage(imgPath.."ball13.png")
  nxtpg = love.graphics.newImage(imgPath.."nxtpg.png")
  prvpg = love.graphics.newImage(imgPath.."prvpg.png")
  healthSPR = love.graphics.newImage(imgPath.."health.png")
  sel = love.graphics.newImage(imgPath.."selector.png")
  sel2 = love.graphics.newImage(imgPath.."selector2.png")
  sel3 = love.graphics.newImage(imgPath.."selector3.png")
  freeze = love.graphics.newImage(imgPath.."freeze.png")
  ground = love.graphics.newImage(imgPath.."ground.png")
  cloudSPR = love.graphics.newImage(imgPath.."cloud.png")
  cloudSPRZ = love.graphics.newImage(imgPath.."cloudSPR.png")
  bulletR = love.graphics.newImage(imgPath.."bulletR.png")
  bulletL = love.graphics.newImage(imgPath.."bulletL.png")
  coinP = love.graphics.newImage(imgPath.."coin.png")
  ghost = love.graphics.newImage(imgPath.."ghost.png")
  coin_collect = love.audio.newSource(sndPath.."coin_collect.wav","stream")
  death = love.audio.newSource(sndPath.."death.wav","stream")
  bullet_hit = love.audio.newSource(sndPath.."bullet_hit.wav","stream")
  move = love.audio.newSource(sndPath.."move.wav","stream")
  perk = love.audio.newSource(sndPath.."perk.wav","stream")
  perk_done = love.audio.newSource(sndPath.."perk_done.wav","stream")
  purchase = love.audio.newSource(sndPath.."purchase.wav","stream")
  cannot_buy = love.audio.newSource(sndPath.."cannot_buy.wav","stream")
  ig1 = love.audio.newSource(musPath.."ingame1.wav","stream")
  ig2 = love.audio.newSource(musPath.."ingame2.wav","stream")
  ig3 = love.audio.newSource(musPath.."ingame3.wav","stream")
  ig4 = love.audio.newSource(musPath.."ingame4.wav","stream")
  ig5 = love.audio.newSource(musPath.."ingame5.wav","stream")
  ig6 = love.audio.newSource(musPath.."ingame6.wav","stream")
  ts = love.audio.newSource(musPath.."titlescreen.wav","stream")
  st = love.audio.newSource(musPath.."shoptheme.wav","stream")
  ig1:setLooping(true)
  ig2:setLooping(true)
  ig3:setLooping(true)
  ig4:setLooping(true)
  ig5:setLooping(true)
  ig6:setLooping(true)
  ts:setLooping(true)
  st:setLooping(true)
  -----------------
  
  -- choose song --
  musMAX = 6
  igR = 0
  sel_music = false
  lastIGR = 0
  function vol()
    coin_collect:setVolume(masterVolume*sfxVolume)
    death:setVolume(masterVolume*sfxVolume)
    bullet_hit:setVolume(masterVolume*sfxVolume)
    move:setVolume(masterVolume*sfxVolume)
    perk:setVolume(masterVolume*sfxVolume)
    perk_done:setVolume(masterVolume*sfxVolume)
    purchase:setVolume(masterVolume*sfxVolume)
    cannot_buy:setVolume(masterVolume*sfxVolume)
    ig1:setVolume(masterVolume*musicVolume)
    ig2:setVolume(masterVolume*musicVolume)
    ig3:setVolume(masterVolume*musicVolume)
    ig4:setVolume(masterVolume*musicVolume)
    ig5:setVolume(masterVolume*musicVolume)
    ig6:setVolume(masterVolume*musicVolume)
    ts:setVolume(masterVolume*musicVolume)
    st:setVolume(masterVolume*musicVolume)
  end
  -----------------
  
  -- coin --
  coinSPRv = 1
  coinSPRc = 30
  coinSPRcD = coinSPRc
  coinsTBL = {}
  min = 600
  max = 1200
  coin_timer = love.math.random(min,max)
  collected = 0
  coins = 0
  function spawnCoin()
    coin = {}
    coin.moving = true
    coin.comingFrom = "None"
    coin.TARGETy = 0
    coin.x = 0
    coin.y = 0
    rando = love.math.random(1,2)
    if rando == 1 then
      coin.TARGETy = love.math.random(50,150)
      coin.y = -50
      coin.comingFrom = "Down"
      coin.x = (objects.ball.body:getX() - 25) - (coin.TARGETy - coin.y)
    elseif rando == 2 then
      coin.TARGETy = love.math.random(wh-200,wh-100)
      coin.y = wh + 50
      coin.comingFrom = "Up"
      coin.x = (objects.ball.body:getX() - 25) + (coin.TARGETy - coin.y)
    end
    table.insert(coinsTBL,coin)
  end
  ----------
  
  -- physics --
  love.physics.setMeter(64)
  world = love.physics.newWorld(0,9.81*64,true)
  objects = {}
  objects.ball = {}
  objects.ball.radius = 25
  objects.ball.body = love.physics.newBody(world,ww/2,wh/2,"dynamic")
  objects.ball.shape = love.physics.newCircleShape(objects.ball.radius)
  objects.ball.fixture = love.physics.newFixture(objects.ball.body,objects.ball.shape,1)
  -------------
  
  -- game states --
  game_over = false
  game_in_session = false
  game_started = false
  instantRespawn = false
  function gameOver()
    if health < 1 then
      if instantRespawn == false then
        love.audio.stop(ig1)
        love.audio.stop(ig2)
        love.audio.stop(ig3)
        love.audio.stop(ig4)
        love.audio.stop(ig5)
        love.audio.stop(ig6)
        love.audio.play(death)
      end
      game_over = true
      game_in_session = false
      if bestScore < score then
        bestScore = score
      end
      if instantRespawn == false then
        for i=1,collected do
          coins = coins + 1
        end
      end
      frz_value = 0
      grd_value = 0
      cld_value = 0
      blc_value = 0
      ghb_value = 0
      if instantRespawn == true then
        restartGame()
        for i=1,#bullets do
          table.remove(bullets,1)
        end
      end
    end
  end

  function restartGame()
    love.audio.stop(death)
    health = Dhealth
    if instantRespawn == false then
      coin_timer = love.math.random(min,max)
      for i=1,#coinsTBL do
        table.remove(coinsTBL,1)
      end
    end
    db = "none"
    score = 0
    scoreupdater = dscoreupdater
    if instantRespawn == false then
      collected = 0
    end
    death_boost = 0
    objects.ball.body:setPosition(ww/2,wh/2)
    objects.ball.body:setLinearVelocity(0,0)
    game_over = false
    if instantRespawn == true then
      game_in_session = true
    end
  end
  -----------------
  
  -- ball --
  health = 1
  Dhealth = 0
  ballColorR = 0
  ballColorG = 0
  ballColorB = 0
  death_boost = 0
  db = "none"
  ----------
  
  -- bullets --
  bullets = {}
  bul_timer = 47
  DE_bul_timer = bul_timer
  function fireBullet()
    bullet = {}
    bullet.x = 0
    bullet.d = "none"
    bullet.w = 15
    bullet.h = 10
    choose = love.math.random(1,10)
    if choose >= 1 and choose <= 5 then
      bullet.x = -50
      bullet.d = "left"
    elseif choose >= 6 and choose <= 10 then
      bullet.x = ww + bullet.w
      bullet.d = "right"
    end
    bullet.y = love.math.random(0,wh)
    bullet.s = 7
    table.insert(bullets,bullet)
  end
  -------------
  
  -- clouds --
  clouds = {}
  cloud_timer = 0
  DE_cloud_timer = 600
  function makeCloud()
    cloud = {}
    cloud.h = love.math.random(50,200)
    randomDec = {1.3,1.4,1.5,1.6,1.7,1.8,1.9,2}
    rando = love.math.random(1,#randomDec)
    cloud.w = cloud.h * randomDec[rando]
    cloud.x = ww + cloud.w
    cloud.y = love.math.random(300,450)
    table.insert(clouds,cloud)
  end
  ------------
  
  -- flash --
  red_opacity = 0
  flash = false
  sec_flash = false
  
  blue_flash = false
  secblue_flash = false
  blue_opacity = 0
  
  gray_flash = false
  secgray_flash = false
  gray_opacity = 0
  
  white_flash = false
  secwhite_flash = false
  white_opacity = 0
  
  yellow_flash = false
  secyellow_flash = false
  yellow_opacity = 0
  
  purple_flash = false
  secpurple_flash = false
  purple_opacity = 0
  -----------
  
  -- score --
  score = 0
  bestScore = 0
  scoreupdater = 60
  dscoreupdater = scoreupdater
  -----------
  
  -- shop --
  inShop = false
  selX = 50
  selY = 245
  xSel = 1
  ySel = 1
  xLimit = 4
  yLimit = 3
  xSel2 = 2
  ySel2 = 0
  xLimit2 = 2
  yLimit2 = 3
  buttons = {}
  done = false
  entry = 1
  entry2 = 1
  ballTypes = {1,2,3,4,5,6,7,8,9,10,11,12}
  num1tf = 1
  num2tf = 1
  num3tf = 1
  num4tf = 1
  num5tf = 1
  num6tf = 1
  num7tf = 1
  num8tf = 1
  num9tf = 1
  num10tf = 1
  num11tf = 1
  num12tf = 1
  slot1 = 0
  b1 = 0
  slot2 = 0
  b2 = 0
  slot3 = 0
  b3 = 0
  slot4 = 0
  b4 = 0
  slot5 = 0
  b5 = 0
  slot6 = 0
  b6 = 0
  slot7 = 0
  b7 = 0
  slot8 = 0
  b8 = 0
  slot9 = 0
  b9 = 0
  slot10 = 0
  b10 = 0
  slot11 = 0
  b11 = 0
  slot12 = 0
  b12 = 0
  shopPG = 1
  function removeFromTable(number)
    for i=1,#ballTypes do
      if ballTypes[i] == number then
        table.remove(ballTypes,i)
      end
    end
  end
  
  function newButton(xc,yc)
    button = {}
    button.x = xc
    button.y = yc
    button.unlocked = false
    button.ballType = "0"
    button.hithere = 0
    if xc == 50 and yc == 245 and slot1 == 1 then
      button.hithere = 1
      button.unlocked = true
    elseif xc == 200 and yc == 245 and slot2 == 1 then
      button.hithere = 2
      button.unlocked = true
    elseif xc == 350 and yc == 245 and slot3 == 1 then
      button.hithere = 3
      button.unlocked = true
    elseif xc == 500 and yc == 245 and slot4 == 1 then
      button.hithere = 4
      button.unlocked = true
    elseif xc == 50 and yc == 395 and slot5 == 1 then
      button.hithere = 5
      button.unlocked = true
    elseif xc == 200 and yc == 395 and slot6 == 1 then
      button.hithere = 6
      button.unlocked = true
    elseif xc == 350 and yc == 395 and slot7 == 1 then
      button.hithere = 7
      button.unlocked = true
    elseif xc == 500 and yc == 395 and slot8 == 1 then
      button.hithere = 8
      button.unlocked = true
    elseif xc == 50 and yc == 545 and slot9 == 1 then
      button.hithere = 9
      button.unlocked = true
    elseif xc == 200 and yc == 545 and slot10 == 1 then
      button.hithere = 10
      button.unlocked = true
    elseif xc == 350 and yc == 545 and slot11 == 1 then
      button.hithere = 11
      button.unlocked = true
    elseif xc == 500 and yc == 545 and slot12 == 1 then
      button.hithere = 12
      button.unlocked = true
    end
    if b1 == button.hithere then
      button.ballType = 1
    elseif b2 == button.hithere then
      button.ballType = 2
    elseif b3 == button.hithere then
      button.ballType = 3
    elseif b4 == button.hithere then
      button.ballType = 4
    elseif b5 == button.hithere then
      button.ballType = 5
    elseif b6 == button.hithere then
      button.ballType = 6
    elseif b7 == button.hithere then
      button.ballType = 7
    elseif b8 == button.hithere then
      button.ballType = 8
    elseif b9 == button.hithere then
      button.ballType = 9
    elseif b10 == button.hithere then
      button.ballType = 10
    elseif b11 == button.hithere then
      button.ballType = 11
    elseif b12 == button.hithere then
      button.ballType = 12
    end
    table.insert(buttons,button)
  end

  function checkEntry()
    if xSel == 1 and ySel == 1 then
      entry = 1
    elseif xSel == 2 and ySel == 1 then
      entry = 2
    elseif xSel == 3 and ySel == 1 then
      entry = 3
    elseif xSel == 4 and ySel == 1 then
      entry = 4
    elseif xSel == 1 and ySel == 2 then
      entry = 5
    elseif xSel == 2 and ySel == 2 then
      entry = 6
    elseif xSel == 3 and ySel == 2 then
      entry = 7
    elseif xSel == 4 and ySel == 2 then
      entry = 8
    elseif xSel == 1 and ySel == 3 then
      entry = 9
    elseif xSel == 2 and ySel == 3 then
      entry = 10
    elseif xSel == 3 and ySel == 3 then
      entry = 11
    elseif xSel == 4 and ySel == 3 then
      entry = 12
    elseif xSel == 4 and ySel == 0 then
      entry = 13
    elseif xSel == 3 and ySel == 0 then
      entry = 14
    end
    love.audio.stop(move)
    love.audio.play(move)
  end

  function checkEntry2()
    if xSel2 == 2 then
      if ySel2 == 0 then
        entry2 = 1
      elseif ySel2 == 1 then
        entry2 = 2
      elseif ySel2 == 2 then
        entry2 = 5
      elseif ySel2 == 3 then
        entry2 = 7
      end
    end
    if xSel2 == 1 then
      if ySel2 == 1 then
        entry2 = 3
      elseif ySel2 == 2 then
        entry2 = 4
      elseif ySel2 == 3 then
        entry2 = 6
      end
    end
    love.audio.stop(move)
    love.audio.play(move)
  end
  ----------
  
  -- perks --
  frz_perks = 0
  frz_value = 0
  frozen = false
  
  grd_perks = 0
  grd_value = 0
  isGround = false
  
  cld_perks = 0
  cld_value = 0
  cloudShield = false
  
  blc_perks = 0
  blc_value = 0
  bulletCoins = false
  
  ghb_perks = 0
  ghb_value = 0
  ghostBall = false
  ghostX = 0
  ghostY = 0
  ghostDir = "up"
  ghostSpeed = 3.5
  
  equipped = 0
  -----------
  
  -- settings --
  inSettings = false
  
  sSel = 1
  sSelx = 50
  sSely = 225
  
  msv = 320
  masterVolume = 1
  
  sfxv = 320
  sfxVolume = 1
  
  muv = 320
  musicVolume = 1
  
  windowPos = 0
  function changeWindow()
    if windowPos == 0 then
      love.window.setMode(650,650)
    elseif windowPos == 1 then
      love.window.setMode(800,650)
    elseif windowPos == 2 then
      love.window.setMode(1000,700)
    elseif windowPos == 3 then
      love.window.setMode(1280,720)
    elseif windowPos == 4 then
      love.window.setMode(0,0)
    end
    ww = love.graphics.getWidth()
    wh = love.graphics.getHeight()
    objects.ball.body:setPosition((ww/2)+death_boost,objects.ball.body:getY())
  end
  
  canFlash = true
  --------------
  
  -- save data --
  saveFileName = "save_data"
  saveFileExtension = "sav"
  fileName = saveFileName.."."..saveFileExtension
  saveAllGameData = true
  tPressed = false
  ays = false
  ays_timer = 100
  aysD = ays_timer
  calledReset = false
  resetTime = 55
  if love.filesystem.getInfo(fileName) and saveAllGameData == true then
    xd = 0
    for line in love.filesystem.lines(fileName) do
      xd = xd + 1
      if xd == 1 then
        bestScore = tonumber(line)
      end
      if xd == 2 then
        ballColorR = tonumber(line)
      end
      if xd == 3 then
        ballColorG = tonumber(line)
      end
      if xd == 4 then
        ballColorB = tonumber(line)
      end
      if xd == 5 then
        coins = tonumber(line)
        if coins > 999999999 then
          coins = 999999999
        end
      end
      if xd == 6 then
        slot1 = tonumber(line)
      end
      if xd == 7 then
        slot2 = tonumber(line)
      end
      if xd == 8 then
        slot3 = tonumber(line)
      end
      if xd == 9 then
        slot4 = tonumber(line)
      end
      if xd == 10 then
        slot5 = tonumber(line)
      end
      if xd == 11 then
        slot6 = tonumber(line)
      end
      if xd == 12 then
        slot7 = tonumber(line)
      end
      if xd == 13 then
        slot8 = tonumber(line)
      end
      if xd == 14 then
        slot9 = tonumber(line)
      end
      if xd == 15 then
        slot10 = tonumber(line)
      end
      if xd == 16 then
        slot11 = tonumber(line)
      end
      if xd == 17 then
        slot12 = tonumber(line)
      end
      if xd == 18 then
        b1 = tonumber(line)
      end
      if xd == 19 then
        b2 = tonumber(line)
      end
      if xd == 20 then
        b3 = tonumber(line)
      end
      if xd == 21 then
        b4 = tonumber(line)
      end
      if xd == 22 then
        b5 = tonumber(line)
      end
      if xd == 23 then
        b6 = tonumber(line)
      end
      if xd == 24 then
        b7 = tonumber(line)
      end
      if xd == 25 then
        b8 = tonumber(line)
      end
      if xd == 26 then
        b9 = tonumber(line)
      end
      if xd == 27 then
        b10 = tonumber(line)
      end
      if xd == 28 then
        b11 = tonumber(line)
      end
      if xd == 29 then
        b12 = tonumber(line)
      end
      if xd == 30 then
        num1tf = tonumber(line)
      end
      if xd == 31 then
        num2tf = tonumber(line)
      end
      if xd == 32 then
        num3tf = tonumber(line)
      end
      if xd == 33 then
        num4tf = tonumber(line)
      end
      if xd == 34 then
        num5tf = tonumber(line)
      end
      if xd == 35 then
        num6tf = tonumber(line)
      end
      if xd == 36 then
        num7tf = tonumber(line)
      end
      if xd == 37 then
        num8tf = tonumber(line)
      end
      if xd == 38 then
        num9tf = tonumber(line)
      end
      if xd == 39 then
        num10tf = tonumber(line)
      end
      if xd == 40 then
        num11tf = tonumber(line)
      end
      if xd == 41 then
        num12tf = tonumber(line)
      end
      if xd == 42 then
        health = tonumber(line)
      end
      if xd == 43 then
        frz_perks = tonumber(line)
      end
      if xd == 44 then
        grd_perks = tonumber(line)
      end
      if xd == 45 then
        cld_perks = tonumber(line)
      end
      if xd == 46 then
        blc_perks = tonumber(line)
      end
      if xd == 47 then
        ghb_perks = tonumber(line)
      end
      if xd == 48 then
        equipped = tonumber(line)
      end
      if xd == 49 then
        masterVolume = tonumber(line)
      end
      if xd == 50 then
        sfxVolume = tonumber(line)
      end
      if xd == 51 then
        musicVolume = tonumber(line)
      end
      if xd == 52 then
        msv = tonumber(line)
      end
      if xd == 53 then
        sfxv = tonumber(line)
      end
      if xd == 54 then
        muv = tonumber(line)
      end
      if xd == 55 then
        windowPos = tonumber(line)
      end
      if xd == 56 then
        if line == "true" then
          canFlash = true
        elseif line == "false" then
          canFlash = false
        end
      end
      if xd == 57 then
        if line == "true" then
          instantRespawn = true
        elseif line == "false" then
          instantRespawn = false
        end
      end
    end
    Dhealth = health
    for i=1,#ballTypes do
      table.remove(ballTypes,1)
    end
    if num1tf == 1 then
      table.insert(ballTypes,1)
    end
    if num2tf == 1 then
      table.insert(ballTypes,2)
    end
    if num3tf == 1 then
      table.insert(ballTypes,3)
    end
    if num4tf == 1 then
      table.insert(ballTypes,4)
    end
    if num5tf == 1 then
      table.insert(ballTypes,5)
    end
    if num6tf == 1 then
      table.insert(ballTypes,6)
    end
    if num7tf == 1 then
      table.insert(ballTypes,7)
    end
    if num8tf == 1 then
      table.insert(ballTypes,8)
    end
    if num9tf == 1 then
      table.insert(ballTypes,9)
    end
    if num10tf == 1 then
      table.insert(ballTypes,10)
    end
    if num11tf == 1 then
      table.insert(ballTypes,11)
    end
    if num12tf == 1 then
      table.insert(ballTypes,12)
    end
  elseif not love.filesystem.getInfo(fileName) or saveAllGameData == false then
    ballColorR = 193
    ballColorG = 47
    ballColorB = 14
    Dhealth = health
  end
  function saveGame()
    if saveAllGameData == true then
      love.filesystem.write(fileName,bestScore.."\r\n"..ballColorR.."\r\n"..ballColorG.."\r\n"..ballColorB.."\r\n"..coins.."\r\n"..slot1.."\r\n"..slot2.."\r\n"..slot3.."\r\n"..slot4.."\r\n"..slot5.."\r\n"..slot6.."\r\n"..slot7.."\r\n"..slot8.."\r\n"..slot9.."\r\n"..slot10.."\r\n"..slot11.."\r\n"..slot12.."\r\n"..b1.."\r\n"..b2.."\r\n"..b3.."\r\n"..b4.."\r\n"..b5.."\r\n"..b6.."\r\n"..b7.."\r\n"..b8.."\r\n"..b9.."\r\n"..b10.."\r\n"..b11.."\r\n"..b12.."\r\n"..num1tf.."\r\n"..num2tf.."\r\n"..num3tf.."\r\n"..num4tf.."\r\n"..num5tf.."\r\n"..num6tf.."\r\n"..num7tf.."\r\n"..num8tf.."\r\n"..num9tf.."\r\n"..num10tf.."\r\n"..num11tf.."\r\n"..num12tf.."\r\n"..health.."\r\n"..frz_perks.."\r\n"..grd_perks.."\r\n"..cld_perks.."\r\n"..blc_perks.."\r\n"..ghb_perks.."\r\n"..equipped.."\r\n"..masterVolume.."\r\n"..sfxVolume.."\r\n"..musicVolume.."\r\n"..msv.."\r\n"..sfxv.."\r\n"..muv.."\r\n"..windowPos.."\r\n"..tostring(canFlash).."\r\n"..tostring(instantRespawn))
    end
  end
  ---------------
  
  -- finalization --
  changeWindow()
  vol()
  love.audio.play(ts)
  ------------------
  
end

function love.keypressed(key)
  if key == "escape" then -- return to title screen or exit game
    if game_started == false and game_in_session == false and inShop == false and inSettings == false then
      love.event.quit()
    elseif game_started == true and game_in_session == false then
      love.audio.play(ts)
      restartGame()
      game_started = false
    end
  elseif key == "i" and inShop == false and inSettings == false then
    if instantRespawn == false then
      instantRespawn = true
    else
      instantRespawn = false
    end
  elseif key == "t" and inShop == false and inSettings == false and game_in_session == false and game_over == false and game_started == false then
    tPressed = true
    love.event.quit()
  elseif key == "r" and game_over == true then -- restart game
    game_in_session = true
    restartGame()
    sel_music = true
    for i=1,#bullets do
      table.remove(bullets,1)
    end
  elseif key == "o" and game_started == false and inShop == false then -- settings
    if inSettings == false then
      love.audio.stop(ts)
      love.audio.play(st)
      inSettings = true
    elseif inSettings == true then
      love.audio.stop(st)
      love.audio.play(ts)
      inSettings = false
    end
  elseif key == "y" and game_started == false and inShop == false and inSettings == false then -- reset data
    if ays == false then
      ays = true
    elseif ays == true then
      calledReset = true
      saveGame()
    end
  elseif key == "g" and game_started == false and inSettings == false then -- shop
    if inShop == false then
      love.audio.stop(ts)
      love.audio.play(st)
      inShop = true
    elseif inShop == true then
      love.audio.stop(st)
      love.audio.play(ts)
      inShop = false
    end
  
  -- navigation --
  elseif (key == "w" or key == "up") then
    if inShop == true then
      if shopPG == 1 then
        if ySel > 1 or entry == 4 or entry == 3 then
          ySel = ySel - 1
          selY = selY - 150
          checkEntry()
        end
      elseif shopPG == 2 then
        if ySel2 > 0 then
          ySel2 = ySel2 - 1
          selY = selY - 150
          if entry2 == 2 then
            selX = selX - 50
          end
          if entry2 == 3 then
            selX = selX + 300
            xSel2 = xSel2 + 1
          end
          checkEntry2()
        end
      end
    end
    if game_over == false and game_in_session == true and ghostBall == true then
      ghostDir = "up"
    end
    if inSettings == true and sSel > 1 then
      if sSel == 5 then
        sSely = sSely + 5
      end
      sSel = sSel - 1
      sSely = sSely - 100
      love.audio.stop(move)
      love.audio.play(move)
    end
  elseif (key == "a" or key == "left") then
    if inShop == true then
      if shopPG == 1 then
        if (xSel > 1 and ySel ~= 0) or entry == 13 then
          xSel = xSel - 1
          selX = selX - 150
          checkEntry()
        end
      elseif shopPG == 2 then
        if (xSel2 > 1 and ySel2 ~= 0) then
          xSel2 = xSel2 - 1
          selX = selX - 350
          checkEntry2()
        end
      end
    end
    if game_over == false and game_in_session == true and ghostBall == true then
      ghostDir = "left"
    end
    if inSettings == true then
      if sSel == 1 then
        if windowPos > 0 then
          windowPos = windowPos - 1
          changeWindow()
          love.audio.stop(move)
          love.audio.play(move)
        end
      elseif sSel == 2 then
        if msv > 50 then
          masterVolume = masterVolume - 0.05
          msv = msv - 13.5
          if msv <= 50 then
            masterVolume = 0
          end
          vol()
          love.audio.stop(move)
          love.audio.play(move)
        end
      elseif sSel == 3 then
        if sfxv > 50 then
          sfxVolume = sfxVolume - 0.05
          sfxv = sfxv - 13.5
          if sfxv <= 50 then
            sfxVolume = 0
          end
          vol()
          love.audio.stop(move)
          love.audio.play(move)
        end
      elseif sSel == 4 then
        if muv > 50 then
          musicVolume = musicVolume - 0.05
          muv = muv - 13.5
          if muv <= 50 then
            musicVolume = 0
          end
          vol()
          love.audio.stop(move)
          love.audio.play(move)
        end
      elseif sSel == 5 then
        if canFlash == true then
          love.audio.stop(move)
          love.audio.play(move)
        end
        canFlash = false
      end
    end
  elseif (key == "s" or key == "down") then
    if inShop == true then
      if shopPG == 1 then
        if ySel < yLimit then
          ySel = ySel + 1
          selY = selY + 150
          checkEntry()
        end
      elseif shopPG == 2 then
        if ySel2 < yLimit2 then
          ySel2 = ySel2 + 1
          selY = selY + 150
          if entry2 == 1 then
            selX = selX + 50
          end
          checkEntry2()
        end
      end
    end
    if game_over == false and game_in_session == true and ghostBall == true then
      ghostDir = "down"
    end
    if inSettings == true and sSel < 5 then
      sSel = sSel + 1
      sSely = sSely + 100
      love.audio.stop(move)
      love.audio.play(move)
      if sSel == 5 then
        sSely = sSely - 5
      end
    end
  elseif (key == "d" or key == "right") then
    if inShop == true then
      if shopPG == 1 then
        if xSel < xLimit then
          xSel = xSel + 1
          selX = selX + 150
          checkEntry()
        end
      elseif shopPG == 2 then
        if xSel2 < xLimit2 then
          xSel2 = xSel2 + 1
          selX = selX + 350
          checkEntry2()
        end
      end
    end
    if game_over == false and game_in_session == true and ghostBall == true then
      ghostDir = "right"
    end
    if inSettings == true then
      if sSel == 1 then
        if windowPos < 4 then
          windowPos = windowPos + 1
          changeWindow()
          love.audio.stop(move)
          love.audio.play(move)
        end
      elseif sSel == 2 then
        if msv < 320 then
          masterVolume = masterVolume + 0.05
          msv = msv + 13.5
          vol()
          love.audio.stop(move)
          love.audio.play(move)
        end
      elseif sSel == 3 then
        if sfxv < 320 then
          sfxVolume = sfxVolume + 0.05
          sfxv = sfxv + 13.5
          vol()
          love.audio.stop(move)
          love.audio.play(move)
        end
      elseif sSel == 4 then
        if muv < 320 then
          musicVolume = musicVolume + 0.05
          muv = muv + 13.5
          vol()
          love.audio.stop(move)
          love.audio.play(move)
        end
      elseif sSel == 5 then
        if canFlash == false then
          love.audio.stop(move)
          love.audio.play(move)
        end
        canFlash = true
      end
    end
  -----------------------
  
  elseif key == "space" then
    if game_started == false and inShop == false and inSettings == false then
      for i=1,#bullets do
        table.remove(bullets,1)
      end
      love.audio.stop(ts)
      sel_music = true
      game_in_session = true
      objects.ball.body:setPosition(ww/2,wh/2)
      objects.ball.body:setLinearVelocity(0,0)
      bul_timer = DE_bul_timer
      game_started = true
    elseif inShop == true and entry ~= 14 and buttons[entry].unlocked == false and shopPG == 1 then
      if coins >= 25 then
        Lentry = buttons[entry]
        if entry == 1 then
          slot1 = 1
        elseif entry == 2 then
          slot2 = 1
        elseif entry == 3 then
          slot3 = 1
        elseif entry == 4 then
          slot4 = 1
        elseif entry == 5 then
          slot5 = 1
        elseif entry == 6 then
          slot6 = 1
        elseif entry == 7 then
          slot7 = 1
        elseif entry == 8 then
          slot8 = 1
        elseif entry == 9 then
          slot9 = 1
        elseif entry == 10 then
          slot10 = 1
        elseif entry == 11 then
          slot11 = 1
        elseif entry == 12 then
          slot12 = 1
        end
        rando = love.math.random(1,#ballTypes)
        chosen = ballTypes[rando]
        if chosen == 1 then
          b1 = entry
          num1tf = 0
          removeFromTable(chosen)
        elseif chosen == 2 then
          b2 = entry
          num2tf = 0
          removeFromTable(chosen)
        elseif chosen == 3 then
          b3 = entry
          num3tf = 0
          removeFromTable(chosen)
        elseif chosen == 4 then
          b4 = entry
          num4tf = 0
          removeFromTable(chosen)
        elseif chosen == 5 then
          b5 = entry
          num5tf = 0
          removeFromTable(chosen)
        elseif chosen == 6 then
          b6 = entry
          num6tf = 0
          removeFromTable(chosen)
        elseif chosen == 7 then
          b7 = entry
          num7tf = 0
          removeFromTable(chosen)
        elseif chosen == 8 then
          b8 = entry
          num8tf = 0
          removeFromTable(chosen)
        elseif chosen == 9 then
          b9 = entry
          num9tf = 0
          removeFromTable(chosen)
        elseif chosen == 10 then
          b10 = entry
          num10tf = 0
          removeFromTable(chosen)
        elseif chosen == 11 then
          b11 = entry
          num11tf = 0
          removeFromTable(chosen)
        elseif chosen == 12 then
          b12 = entry
          num12tf = 0
          removeFromTable(chosen)
        end
        Lentry.unlocked = true
        Lentry.ballType = chosen
        coins = coins - 25
        love.audio.stop(purchase)
        love.audio.play(purchase)
      elseif coins < 25 then
        love.audio.stop(cannot_buy)
        love.audio.play(cannot_buy)
      end
    elseif inShop == true and entry ~= 14 and buttons[entry].unlocked == true and shopPG == 1 then
      Lentry = buttons[entry]
      r = 0
      g = 0
      b = 0
      if Lentry.ballType == 1 then
        r = 255
        g = 255
        b = 255
      elseif Lentry.ballType == 2 then
        r = 0
        g = 82
        b = 255
      elseif Lentry.ballType == 3 then
        r = 48
        g = 153
        b = 48
      elseif Lentry.ballType == 4 then
        r = 255
        g = 63
        b = 63
      elseif Lentry.ballType == 5 then
        r = 255
        g = 216
        b = 0
      elseif Lentry.ballType == 6 then
        r = 255
        g = 132
        b = 24
      elseif Lentry.ballType == 7 then
        r = 122
        g = 75
        b = 46
      elseif Lentry.ballType == 8 then
        r = 255
        g = 89
        b = 232
      elseif Lentry.ballType == 9 then
        r = 127
        g = 63
        b = 191
      elseif Lentry.ballType == 10 then
        r = 128
        g = 128
        b = 128
      elseif Lentry.ballType == 11 then
        r = 17
        g = 17
        b = 17
      elseif Lentry.ballType == 12 then
        r = 155
        g = 216
        b = 0
      elseif Lentry.ballType == 13 then
        r = 193
        g = 47
        b = 14
      end
      ballColorR = r
      ballColorG = g
      ballColorB = b
      love.audio.stop(move)
      love.audio.play(move)
    elseif inShop == true and entry == 14 and entry2 == 1 then
      if shopPG == 1 then
        shopPG = 2
      else
        shopPG = 1
      end
      love.audio.stop(move)
      love.audio.play(move)
    elseif inShop == true and shopPG == 2 and entry2 == 3 then
      if coins >= 80 then
        health = health + 1
        coins = coins - 80
        love.audio.stop(purchase)
        love.audio.play(purchase)
      elseif coins < 80 then
        love.audio.stop(cannot_buy)
        love.audio.play(cannot_buy)
      end
    elseif inShop == true and shopPG == 2 and entry2 == 2 then
      if coins >= 40 then
        frz_perks = frz_perks + 1
        coins = coins - 40
        love.audio.stop(purchase)
        love.audio.play(purchase)
      elseif coins < 40 then
        love.audio.stop(cannot_buy)
        love.audio.play(cannot_buy)
      end
    elseif inShop == true and shopPG == 2 and entry2 == 4 then
      if coins >= 40 then
        grd_perks = grd_perks + 1
        coins = coins - 40
        love.audio.stop(purchase)
        love.audio.play(purchase)
      elseif coins < 40 then
        love.audio.stop(cannot_buy)
        love.audio.play(cannot_buy)
      end
    elseif inShop == true and shopPG == 2 and entry2 == 5 then
      if coins >= 40 then
        cld_perks = cld_perks + 1
        coins = coins - 40
        love.audio.stop(purchase)
        love.audio.play(purchase)
      elseif coins < 40 then
        love.audio.stop(cannot_buy)
        love.audio.play(cannot_buy)
      end
    elseif inShop == true and shopPG == 2 and entry2 == 6 then
      if coins >= 40 then
        blc_perks = blc_perks + 1
        coins = coins - 40
        love.audio.stop(purchase)
        love.audio.play(purchase)
      elseif coins < 40 then
        love.audio.stop(cannot_buy)
        love.audio.play(cannot_buy)
      end
    elseif inShop == true and shopPG == 2 and entry2 == 7 then
      if coins >= 40 then
        ghb_perks = ghb_perks + 1
        coins = coins - 40
        love.audio.stop(purchase)
        love.audio.play(purchase)
      elseif coins < 40 then
        love.audio.stop(cannot_buy)
        love.audio.play(cannot_buy)
      end
    end
  elseif key == "p" and game_started == true and game_over == false then -- use perk
    if equipped == 1 then
      if frz_value >= 10000 then
        frozen = true
        blue_flash = true
        frz_perks = frz_perks - 1
      end
    elseif equipped == 2 then
      if grd_value >= 10000 then
        isGround = true
        extra = extra + 1
        gray_flash = true
        grd_perks = grd_perks - 1
      end
    elseif equipped == 3 then
      if cld_value >= 10000 then
        cloudShield = true
        white_flash = true
        cld_perks = cld_perks - 1
      end
    elseif equipped == 4 then
      if blc_value >= 10000 then
        bulletCoins = true
        yellow_flash = true
        blc_perks = blc_perks - 1
      end
    elseif equipped == 5 then
      if ghb_value >= 10000 then
        ghostX = objects.ball.body:getX()
        ghostY = objects.ball.body:getY()
        ghostBall = true
        extra = extra + 1
        purple_flash = true
        ghb_perks = ghb_perks - 1
      end
    end
    love.audio.play(perk)
  elseif key == "0" and inShop == true and shopPG == 2 then
    equipped = tonumber(key)
    love.audio.stop(move)
    love.audio.play(move)
  elseif key == "1" and inShop == true and shopPG == 2 and frz_perks > 0 then
    equipped = tonumber(key)
    love.audio.stop(move)
    love.audio.play(move)
  elseif key == "2" and inShop == true and shopPG == 2 and grd_perks > 0 then
    equipped = tonumber(key)
    love.audio.stop(move)
    love.audio.play(move)
  elseif key == "3" and inShop == true and shopPG == 2 and cld_perks > 0 then
    equipped = tonumber(key)
    love.audio.stop(move)
    love.audio.play(move)
  elseif key == "4" and inShop == true and shopPG == 2 and blc_perks > 0 then
    equipped = tonumber(key)
    love.audio.stop(move)
    love.audio.play(move)
  elseif key == "5" and inShop == true and shopPG == 2 and ghb_perks > 0 then
    equipped = tonumber(key)
    love.audio.stop(move)
    love.audio.play(move)
  end
end

function love.update(dt)
  if game_over == true then
    if db == "left" then
      death_boost = death_boost + 1.5
    elseif db == "right" then
      death_boost = death_boost - 1.5
    end
    objects.ball.body:setPosition((ww/2)+death_boost,objects.ball.body:getY())
  end
  world:update(dt)
  if game_started == true and #coinsTBL > 0 then
    coinSPRc = coinSPRc - 1
    if coinSPRc < 1 then
      if coinSPRv == 1 then
        coinSPRv = 2
      elseif coinSPRv == 2 then
        coinSPRv = 1
      end
      coinSPRc = coinSPRcD
    end
  end
  if game_started == true and game_over == false then
    scoreupdater = scoreupdater - 1
    coin_timer = coin_timer - 1
    if scoreupdater < 1 then
      score = score + 1
      scoreupdater = dscoreupdater
    end
    if coin_timer < 1 then
      spawnCoin()
      coin_timer = love.math.random(min,max)
    end
    if love.keyboard.isDown("space") then
      objects.ball.body:applyForce(0,-950)
    end
    if objects.ball.body:getY() < -50 or objects.ball.body:getY() > wh + 50 then
      flash = true
      health = 0
      gameOver()
    end
    if objects.ball.body:getY() >= wh - 75 and isGround == true then
      objects.ball.body:setLinearVelocity(0,0)
      objects.ball.body:applyForce(0,-1000)
    end
  end
  if frozen == false then
    bul_timer = bul_timer - 1
  end
  if bul_timer < 1 then
    fireBullet()
    bul_timer = DE_bul_timer
    if game_started == false then
      for i=1,5 do
        if objects.ball.body:getY() >= 200 then
          objects.ball.body:setLinearVelocity(0,0)
          objects.ball.body:applyForce(0,-1750)
        end
      end
    end
  end
  if frozen == false then
    cloud_timer = cloud_timer - 1
  end
  if cloud_timer < 1 then
    makeCloud()
    cloud_timer = DE_cloud_timer
  end
  for _,m in ipairs(bullets) do
    if frozen == false then
      if m.d == "left" then
        m.x = m.x + m.s
      elseif m.d == "right" then
        m.x = m.x - m.s
      end
    end
  end
  for _,r in ipairs(bullets) do
    if r.x < -100 or r.x > ww + 100 then
      table.remove(bullets,_)
    end
  end
  for _,pos in ipairs(clouds) do
    if frozen == false then
      pos.x = pos.x - 1
    end
  end
  for _,coi in ipairs(coinsTBL) do
    if coi.moving == true then
      if coi.comingFrom == "Down" then
        coi.y = coi.y + 1
        coi.x = coi.x + 1
        if coi.y >= coi.TARGETy then
          coi.moving = false
        end
      elseif coi.comingFrom == "Up" then
        coi.y = coi.y - 1
        coi.x = coi.x + 1
        if coi.y <= coi.TARGETy then
          coi.moving = false
        end
      end
    end
  end
  for _,f in ipairs(clouds) do
    if f.x < (0 - f.w) then
      table.remove(clouds,_)
    end
  end
  for _,c in ipairs(bullets) do
    x = objects.ball.body:getX()
    y = objects.ball.body:getY()
    if (c.x >= (x - 30) and c.x <= ((x - 30) + 45)) and (c.y >= (y - 50) and c.y <= ((y - 30) + 50)) and bulletCoins == false then
      if game_over == false and health == 1 then
        db = c.d
      end
      if game_in_session == true then
        flash = true
        health = health - 1
        gameOver()
      else
        flash = true
      end
      love.audio.stop(bullet_hit)
      love.audio.play(bullet_hit)
      table.remove(bullets,_)
    elseif (c.x >= (x - 30) and c.x <= ((x - 30) + 45)) and (c.y >= (y - 45) and c.y <= ((y - 30) + 45)) and bulletCoins == true then
      table.remove(bullets,_)
      collected = collected + 1
      love.audio.stop(coin_collect)
      love.audio.play(coin_collect)
    end
  end
  for _,col in ipairs(coinsTBL) do
    x = objects.ball.body:getX()
    y = objects.ball.body:getY()
    if (col.x >= (x - 80)) and (col.y >= (y - 50) and col.y <= (y + 30)) and game_over == false then
      table.remove(coinsTBL,_)
      collected = collected + 1
      love.audio.stop(coin_collect)
      love.audio.play(coin_collect)
    end
  end
  if flash == true and sec_flash == false then
    red_opacity = red_opacity + 0.1
    if red_opacity >= 1 then
      flash = false
      sec_flash = true
    end
  end
  if sec_flash == true then
    red_opacity = red_opacity - 0.1
    if red_opacity <= 0 then
      sec_flash = false
      red_opacity = 0
    end
  end
  if blue_flash == true then
    blue_opacity = blue_opacity + 0.1
    if blue_opacity >= 1 then
      blue_flash = false
      secblue_flash = true
    end
  end
  if secblue_flash == true then
    blue_opacity = blue_opacity - 0.1
    if blue_opacity <= 0 then
      secblue_flash = false
      blue_opacity = 0
    end
  end
  if gray_flash == true then
    gray_opacity = gray_opacity + 0.1
    if gray_opacity >= 1 then
      gray_flash = false
      secgray_flash = true
    end
  end
  if secgray_flash == true then
    gray_opacity = gray_opacity - 0.1
    if gray_opacity <= 0 then
      secgray_flash = false
      gray_opacity = 0
    end
  end
  if white_flash == true then
    white_opacity = white_opacity + 0.1
    if white_opacity >= 1 then
      white_flash = false
      secwhite_flash = true
    end
  end
  if secwhite_flash == true then
    white_opacity = white_opacity - 0.1
    if white_opacity <= 0 then
      secwhite_flash = false
      white_opacity = 0
    end
  end
  if yellow_flash == true then
    yellow_opacity = yellow_opacity + 0.1
    if yellow_opacity >= 1 then
      yellow_flash = false
      secyellow_flash = true
    end
  end
  if secyellow_flash == true then
    yellow_opacity = yellow_opacity - 0.1
    if yellow_opacity <= 0 then
      secyellow_flash = false
      yellow_opacity = 0
    end
  end
  if purple_flash == true then
    purple_opacity = purple_opacity + 0.1
    if purple_opacity >= 1 then
      purple_flash = false
      secpurple_flash = true
    end
  end
  if secpurple_flash == true then
    purple_opacity = purple_opacity - 0.1
    if purple_opacity <= 0 then
      secpurple_flash = false
      purple_opacity = 0
    end
  end
  if ays == true then
    ays_timer = ays_timer - 1
    if ays_timer < 1 then
      ays = false
      ays_timer = aysD
    end
  end
  if calledReset == true then
    if resetTime == 55 then
      love.filesystem.remove(fileName)
    end
    resetTime = resetTime - 1
    if resetTime < 1 then
      love.timer.sleep(1)
      love.event.quit("restart")
    end
  end
  if game_started == true and game_over == false and frz_perks > 0 and frz_value < 10000 and equipped == 1 then
    frz_value = frz_value + 2
  end
  if game_started == true and game_over == false and frozen == true then
    frz_value = frz_value - 20
    if frz_value < 1 then
      for i=1,#bullets do
        table.remove(bullets,1)
      end
      blue_flash = true
      frozen = false
      if frz_perks < 1 then
        equipped = 0
      end
      love.audio.play(perk_done)
    end
  end
  if game_started == true and game_over == false and grd_perks > 0 and grd_value < 10000 and equipped == 2 then
    grd_value = grd_value + 2
  end
  if game_started == true and game_over == false and isGround == true then
    grd_value = grd_value - 10
    if grd_value < 1 then
      gray_flash = true
      isGround = false
      extra = extra - 1
      if grd_perks < 1 then
        equipped = 0
      end
      love.audio.play(perk_done)
    end
  end
  if game_started == true and game_over == false and cld_perks > 0 and cld_value < 10000 and equipped == 3 then
    cld_value = cld_value + 2
  end
  if game_started == true and game_over == false and cloudShield == true then
    cld_value = cld_value - 15
    if cld_value < 1 then
      white_flash = true
      cloudShield = false
      if cld_perks < 1 then
        equipped = 0
      end
      love.audio.play(perk_done)
    end
  end
  if game_started == true and game_over == false and blc_perks > 0 and blc_value < 10000 and equipped == 4 then
    blc_value = blc_value + 2
  end
  if game_started == true and game_over == false and bulletCoins == true then
    blc_value = blc_value - 20
    if blc_value < 1 then
      yellow_flash = true
      bulletCoins = false
      if blc_perks < 1 then
        equipped = 0
      end
      love.audio.play(perk_done)
    end
  end
  if game_started == true and game_over == false and ghb_perks > 0 and ghb_value < 10000 and equipped == 5 then
    ghb_value = ghb_value + 2
  end
  if game_started == true and game_over == false and ghostBall == true then
    ghb_value = ghb_value - 10
    if ghb_value < 1 then
      purple_flash = true
      ghostBall = false
      extra = extra - 1
      if ghb_perks < 1 then
        equipped = 0
      end
      love.audio.play(perk_done)
    end
  end
  if cloudShield == true then
    for x,c in pairs(bullets) do
      for _,cl in pairs(clouds) do
        if c.x >= (cl.x) and c.x <= (cl.x + (cl.w)) then
          if c.y >= cl.y and (c.y - 15) <= (cl.y + (cl.h - 15)) then
            table.remove(bullets,x)
          end
        end
      end
    end
  end
  if ghostBall == true then
    if ghostDir == "up" then
      ghostY = ghostY - ghostSpeed
      if ghostY < -60 then
        ghb_value = 0
      end
    elseif ghostDir == "down" then
      ghostY = ghostY + ghostSpeed
      if ghostY > wh + 60 then
        ghb_value = 0
      end
    elseif ghostDir == "left" then
      ghostX = ghostX - ghostSpeed
      if ghostX < -60 then
        ghb_value = 0
      end
    elseif ghostDir == "right" then
      ghostX = ghostX + ghostSpeed
      if ghostX > ww + 60 then
        ghb_value = 0
      end
    end
  end
  for _,ki in ipairs(bullets) do
    x = ghostX
    y = ghostY
    if (ki.x >= (x - 60) and ki.x <= (x + 30)) and (ki.y >= (y - 75) and ki.y <= (y + 30)) and ghostBall == true then
      table.remove(bullets,_)
    end
  end
  if sel_music == true then
    igR = love.math.random(1,musMAX)
    if igR ~= lastIGR then
      if igR == 1 then
        love.audio.play(ig1)
      elseif igR == 2 then
        love.audio.play(ig2)
      elseif igR == 3 then
        love.audio.play(ig3)
      elseif igR == 4 then
        love.audio.play(ig4)
      elseif igR == 5 then
        love.audio.play(ig5)
      elseif igR == 6 then
        love.audio.play(ig6)
      end
      lastIGR = igR
      sel_music = false
    end
  end
end

function love.draw()
  if isGround == true then
    love.graphics.setColor(50/255,50/255,50/255)
    love.graphics.rectangle("fill",0,wh-50,ww,50)
  end
  if objects.ball.body:getY() > -50 and objects.ball.body:getY() < wh + 50 then
    love.graphics.setColor(ballColorR/255,ballColorG/255,ballColorB/255)
    love.graphics.circle("fill",objects.ball.body:getX(),objects.ball.body:getY(),objects.ball.shape:getRadius())
  end
  if bulletCoins == true then
    for _,b in pairs(bullets) do
      love.graphics.setColor(1,1,1)
      if coinSPRv == 1 then
        love.graphics.draw(coinSPR1,b.x,b.y)
      else
        love.graphics.draw(coinSPR2,b.x,b.y)
      end
    end
  else
    for _,b in pairs(bullets) do
      love.graphics.setColor(1,1,1)
      if b.d == "right" then
        love.graphics.draw(bulletR,b.x,b.y+15)
      else
        love.graphics.draw(bulletL,b.x,b.y+15)
      end
    end
  end
  if #coinsTBL > 0 then
    love.graphics.setColor(1,1,1)
    for _,c in pairs(coinsTBL) do
      if coinSPRv == 1 then
        love.graphics.draw(coinSPR1,c.x,c.y)
      else
        love.graphics.draw(coinSPR2,c.x,c.y)
      end
    end
  end
  if #clouds > 0 then
    love.graphics.setColor(1,1,1,.5)
    for _,cl in pairs(clouds) do
      love.graphics.draw(cloudSPRZ,cl.x,cl.y,0,cl.w/65,cl.h/50)
    end
  end
  love.graphics.setColor(0,0,0)
  if game_over == true then
    love.graphics.setColor(1,0,0)
    love.graphics.print("Game over!",7,15,0,3,3)
    love.graphics.setColor(0,0,0)
    if score == 1 then
      love.graphics.print("Your score: "..score.." second",7,60,0,2,2)
    else
      love.graphics.print("Your score: "..score.." seconds",7,60,0,2,2)
    end
    if bestScore == 1 then
      love.graphics.print("Your best score: "..bestScore.." second",7,105,0,2,2)
    else
      love.graphics.print("Your best score: "..bestScore.." seconds",7,105,0,2,2)
    end
    love.graphics.setColor(1,222/255,0)
    if collected == 1 then
      love.graphics.print("You earned "..collected.." total coin!",7,150,0,2,2)
    else
      love.graphics.print("You earned "..collected.." total coins!",7,150,0,2,2)
    end
    love.graphics.setColor(0,0,0)
    love.graphics.print("Press 'r' to retry.",7,195,0,2,2)
    love.graphics.print("Press 'escape' to return to the title screen.",7,240,0,2,2)
  end
  if game_started == false and inShop == false and inSettings == false then
    love.graphics.print("Press 'space' to start!",7,15,0,2,2)
    love.graphics.print("Press and hold 'space' to boost the ball upwards.",7,60,0,2,2)
    love.graphics.print("Press 'g' to visit the shop.",7,105,0,2,2)
    love.graphics.print("Press 'o' to open settings.",7,150,0,2,2)
    love.graphics.print("Press 'i' to toggle instant respawn.",7,195,0,2,2)
    love.graphics.print("Press 't' to quit without saving your data.",7,240,0,2,2)
    love.graphics.print("Press 'y' to erase all sava data.",7,285,0,2,2)
    if ays == true then
      love.graphics.print("Are you sure? (Press 'y' again to confirm.)",7,330,0,2,2)
    end
  end
  if inSettings == true then
    love.graphics.print("Use 'w' and 's' or 'up' and 'down' to navigate.",7,15,0,2,2)
    love.graphics.print("Use 'a' and 'd' or 'left' and 'right' to change.",7,60,0,2,2)
    love.graphics.print("Press 'o' to return to the title screen.",7,105,0,2,2)
    love.graphics.setColor(1,0,0)
    love.graphics.print("Warning: Higher screen resolutions may cause lag.",50,205)
    love.graphics.setColor(0,0,0,.5)
    love.graphics.rectangle("fill",50,325,300,30)
    love.graphics.rectangle("fill",50,425,300,30)
    love.graphics.rectangle("fill",50,525,300,30)
    love.graphics.setColor(0,0,0)
    love.graphics.print("Resolution",130,175,0,2,2)
    if windowPos == 4 then
      love.graphics.print(ww.." x "..wh.." [FULLSCREEN]",90,230,0,1.5,1.5)
    else
      love.graphics.print(ww.." x "..wh,150,230,0,1.5,1.5)
    end
    love.graphics.print("Master Volume",110,275,0,2,2)
    love.graphics.print("SFX Volume",125,375,0,2,2)
    love.graphics.print("Music Volume",115,475,0,2,2)
    love.graphics.rectangle("fill",msv,325,30,30)
    love.graphics.rectangle("fill",sfxv,425,30,30)
    love.graphics.rectangle("fill",muv,525,30,30)
    love.graphics.print(100*masterVolume.."%",365,325,0,2,2)
    love.graphics.print(100*sfxVolume.."%",365,425,0,2,2)
    love.graphics.print(100*musicVolume.."%",365,525,0,2,2)
    love.graphics.print("Flash",160,575,0,2,2)
    love.graphics.print(tostring(canFlash),175,625,0,1.5,1.5)
    love.graphics.setColor(1,1,1)
    love.graphics.draw(sel3,sSelx,sSely)
  end
  if game_started == true and game_over == false then
    if equipped ~= 0 then
      love.graphics.setColor(0,0,0)
      love.graphics.rectangle("fill",15,15,100,25)
    end
    if equipped == 1 then
      love.graphics.setColor(0,1,1)
      love.graphics.rectangle("fill",15,15,frz_value/100,25)
    elseif equipped == 2 then
      love.graphics.setColor(90/255,90/255,90/255)
      love.graphics.rectangle("fill",15,15,grd_value/100,25)
    elseif equipped == 3 then
      love.graphics.setColor(1,1,1)
      love.graphics.rectangle("fill",15,15,cld_value/100,25)
    elseif equipped == 4 then
      love.graphics.setColor(1,216/255,0)
      love.graphics.rectangle("fill",15,15,blc_value/100,25)
    elseif equipped == 5 then
      love.graphics.setColor(120/255,0,.5)
      love.graphics.rectangle("fill",15,15,ghb_value/100,25)
      love.graphics.setColor(0,0,0)
      if frz_value >= 10000 or grd_value >= 10000 or cld_value >= 10000 or blc_value >= 10000 or ghb_value >= 10000 then
        love.graphics.print("Press 'p' to use your perk!",15,45,0,2,2)
      end
    end
  end
  if inShop == true then
    x,y = 50,245
    if shopPG == 1 then
      love.graphics.setColor(1,1,1)
      love.graphics.draw(nxtpg,350,95)
      for _,butt in pairs(buttons) do
        if butt.unlocked == false then
          love.graphics.draw(lockedSlot,butt.x,butt.y)
        else
          love.graphics.draw(unlockedSlot,butt.x,butt.y)
          if butt.ballType == 1 then
            love.graphics.draw(ball1,butt.x+16,butt.y+17)
          elseif butt.ballType == 2 then
            love.graphics.draw(ball2,butt.x+16,butt.y+17)
          elseif butt.ballType == 3 then
            love.graphics.draw(ball3,butt.x+16,butt.y+17)
          elseif butt.ballType == 4 then
            love.graphics.draw(ball4,butt.x+16,butt.y+17)
          elseif butt.ballType == 5 then
            love.graphics.draw(ball5,butt.x+16,butt.y+17)
          elseif butt.ballType == 6 then
            love.graphics.draw(ball6,butt.x+16,butt.y+17)
          elseif butt.ballType == 7 then
            love.graphics.draw(ball7,butt.x+16,butt.y+17)
          elseif butt.ballType == 8 then
            love.graphics.draw(ball8,butt.x+16,butt.y+17)
          elseif butt.ballType == 9 then
            love.graphics.draw(ball9,butt.x+16,butt.y+17)
          elseif butt.ballType == 10 then
            love.graphics.draw(ball10,butt.x+16,butt.y+17)
          elseif butt.ballType == 11 then
            love.graphics.draw(ball11,butt.x+16,butt.y+17)
          elseif butt.ballType == 12 then
            love.graphics.draw(ball12,butt.x+16,butt.y+17)
          elseif butt.ballType == 13 then
            love.graphics.draw(ball13,butt.x+16,butt.y+17)
          end
        end
      end
      for i=1,13 do
        if done == false then
          if i ~= 13 then
            newButton(x,y)
            x = x + 150
            if x > 500 then
              y = y + 150
              x = 50
            end
          elseif i == 13 then
            newButton(500,95)
            Bentry = buttons[13]
            Bentry.unlocked = true
            Bentry.ballType = 13
          end
        end
        if i == 13 then
          done = true
        end
      end
      love.graphics.draw(sel,selX,selY)
    elseif shopPG == 2 then
      love.graphics.setColor(1,1,1)
      love.graphics.draw(prvpg,350,95)
      love.graphics.draw(healthSPR,50,245)
      love.graphics.draw(freeze,400,245)
      love.graphics.draw(ground,50,395)
      love.graphics.draw(cloudSPR,400,395)
      love.graphics.draw(coinP,50,545)
      love.graphics.draw(ghost,400,545)
      love.graphics.setColor(0,0,0)
      love.graphics.print("To equip a certain perk, hit the number key that is displayed on said perk button at the top right.",7,200)
      love.graphics.print("You can also press '0' to unequip your perks.",7,215)
      love.graphics.setColor(1,1,1)
      if entry2 ~= 1 then
        love.graphics.draw(sel2,selX,selY)
      else
        love.graphics.draw(sel,selX,selY)
      end
    end
    love.graphics.setColor(0,0,0)
    love.graphics.print("Press 'g' to return to the title screen.",7,15,0,2,2)
    love.graphics.print("Use 'wasd' or 'up, left, down, and right' to navigate.",7,60,0,2,2)
    love.graphics.print("Press 'space' to purchase.",7,105,0,2,2)
    love.graphics.setColor(1,222/255,0)
    if coins == 1 then
      love.graphics.print("You have "..coins.." coin.",7,150,0,2,2)
    else
      love.graphics.print("You have "..coins.." coins.",7,150,0,2,2)
    end
  end
  if canFlash == true then
    love.graphics.setColor(.5,0,0,red_opacity)
    love.graphics.rectangle("fill",0,0,ww,wh)
    love.graphics.setColor(0,1,1,blue_opacity)
    love.graphics.rectangle("fill",0,0,ww,wh)
    love.graphics.setColor(50/255,50/255,50/255,gray_opacity)
    love.graphics.rectangle("fill",0,0,ww,wh)
    love.graphics.setColor(1,1,1,white_opacity)
    love.graphics.rectangle("fill",0,0,ww,wh)
    love.graphics.setColor(1,216/255,0,yellow_opacity)
    love.graphics.rectangle("fill",0,0,ww,wh)
    love.graphics.setColor(120/255,0,.5,purple_opacity)
    love.graphics.rectangle("fill",0,0,ww,wh)
  end
  if ghostBall == true then
    love.graphics.setColor(120/255,0,.5,.5)
    love.graphics.circle("fill",ghostX,ghostY,50)
  end
  if calledReset == true then
    love.graphics.setColor(0,0,0)
    love.graphics.print("Resetting progress...",7,375,0,3,3)
  end
  love.graphics.setColor(0,0,0)
end

function love.quit()
  if inShop == false and inSettings == false and game_in_session == false and game_over == false and calledReset == false and tPressed == false then
    saveGame()
  end
end